

/*
 Horloge mère avec CI DS1307 et AD 9850
 Version 01     Octobre 2012
         02     Mars 2018  (Valeurs boutons) 
     //    switch (val_key) 
     //  {
     //   case 63 : //Select
     
 Mon site http://f5mna.free.fr
*/
//AD9850
 
 #define W_CLK 3       // Pin 3 - connect to AD9850 module word load clock pin (CLK)
 #define FQ_UD 13      // Pin 13 - connect to freq update pin (FQ)
 #define DATA 2        // Pin 2 - connect to serial data load pin (DATA)

 #define pulseHigh(pin) {digitalWrite(pin, HIGH); digitalWrite(pin, LOW); }
 
 //LCD
#include <LiquidCrystal.h>
// LCD RS pin to digital pin 8
// LCD Enable pin to digital pin 9
// LCD D4 pin to digital pin 4
// LCD D5 pin to digital pin 5
// LCD D6 pin to digital pin 6
// LCD D7 pin to digital pin 7
// LCD R/W pin to ground
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

//DS1307
#include <Wire.h>      
#include <DS1307new.h>

uint16_t startAddr = 0x0000;       // Adresse de démarrage Start dans  NV-RAM
uint16_t lastAddr;                 // Nelle addresse des stockage NV-RAM
uint16_t TimeIsSet = 0xaa55;       // Prévient qu'il n'y a pas de remise à l'heure
//
// Pavé touches
#define Touche_PIN  A0    // Entrée des infos boutons

int sensorPin = A0;
int sensorValue = 0; 
int val_key;
int Select;
int Heure;
int Minute;
int Seconde;
int Jour;
int Mois;
int Annee;
int Modif = 0;
char LeMois;
////////////////////////

////// Sorties tensions alternées + avance rapide //////
int Altern1 = 11; // pin 11 tension alternée 
int Altern2 = 12; // pin 12 tension alternée inverse

void setup () {

  pinMode(2, INPUT);                    // Test  SQW pin, D2 = INPUT
  digitalWrite(2, HIGH);                // Test  SQW pin, D2 = Pullup on
 
  RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entree startAddr in NV-RAM address 0x08 
  TimeIsSet = 0xffff;
  RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));  
  RTC.ctrl = 0x00;     // 0x00=disable SQW pin, 0x10=1Hz,
                       // 0x11=4096Hz, 0x12=8192Hz, 0x13=32768Hz
  RTC.setCTRL();

    pinMode( Touche_PIN, INPUT );         //ensure A0 is an input
    digitalWrite( Touche_PIN, LOW );      //ensure pullup is off on A0
    //Presentation
    lcd.begin(16, 2); 
    lcd.setCursor(0, 0);
    lcd.print ("    HORLOGE     ");
    lcd.setCursor(0, 1);
    lcd.print ("F5MNA  Version 2");
    delay(2000);
    lcd.setCursor(0, 0);
    lcd.print ("                 ");
    lcd.setCursor(0, 1);
    lcd.print ("                 ");
    
    ////// Déclaration tension alternée & Avance rapide//////////
    pinMode(Altern1, OUTPUT);
    pinMode(Altern2, OUTPUT);
    //AD9850
    
      pinMode(FQ_UD, OUTPUT);
      pinMode(W_CLK, OUTPUT);
      pinMode(DATA, OUTPUT);
    //pinMode(RESET, OUTPUT);
   
    //pulseHigh(RESET);
     pulseHigh(W_CLK);
     pulseHigh(FQ_UD);  // this pulse enables serial mode - Datasheet page 12 figure 10
}



//////////////////////////////// 
/////      AD9850     //////////
////////////////////////////////
//transfers a byte, a bit at a time, LSB first to the 9850 via serial DATA line
void tfr_byte(byte data)
{
  for (int i=0; i<8; i++, data>>=1) {
    digitalWrite(DATA, data & 0x01);
    pulseHigh(W_CLK);   //after each bit sent, CLK is pulsed high
  }
}

 // frequency calc from datasheet page 8 = <sys clock> * <frequency tuning word>/2^32
  void sendFrequency(double frequency) {
  int32_t freq = frequency * 4294967295/125000000;  // note 125 MHz clock on 9850
  for (int b=0; b<4; b++, freq>>=8) {
    tfr_byte(freq & 0xFF);
  }
  tfr_byte(0x000);   // Final control byte, all 0 for 9850 chip
  pulseHigh(FQ_UD);  // Done!  Should see output
  
}

////////////////////////////
void Bouton ()
{
  
  delay(100);
 
  if ((Select > 0) and (Select < 4))
  {
  lcd.setCursor( 0, 0 );
  lcd.print("                ");
  lcd.setCursor( 4, 0 );
  if (Jour < 10) { lcd.print ("0");}
  lcd.print( Jour );
  lcd.print( ":");
  if (Mois < 10) { lcd.print ("0");}
  lcd.print( Mois );
  lcd.print( ":" );
  lcd.print( Annee );
  
 }
  if ((Select > 3) and (Select < 7))
  {
  lcd.setCursor( 0, 0 );
  lcd.print("               "); 
  lcd.setCursor(4, 0 );
  if (Heure < 10) { lcd.print ("0");}  
  lcd.print(Heure );
  lcd.print( ":");
  if (Minute < 10) { lcd.print ("0");}
  lcd.print( Minute );
  lcd.print( ":" );
    if (Seconde < 10) { lcd.print ("0");}
  lcd.print( Seconde );;
  } 
     
  val_key = 0;                         // RAZ valeur de la touche 
  sensorValue = analogRead(sensorPin); // lecture de la touche
  val_key = int(sensorValue/10);       // valeur entière de la touche / 10
  
  switch (val_key) 
       {
        case 63 : //Select
       { 
        lcd.setCursor( 5, 1 );
        lcd.print( "Select " );
        Select = (Select + 1);
    
        if (Select == 1) {
            lcd.setCursor( 0, 1 );
            lcd.print ("  Reglage jour  ");}
        if (Select == 2) {
            lcd.setCursor( 0, 1 );
            lcd.print ("  Reglage mois  ");}
        if (Select == 3) {
            lcd.setCursor( 0, 1 );
            lcd.print (" Reglage annee  ");}
        if (Select == 4) {
            lcd.setCursor( 0, 1 );
            lcd.print (" Reglage heure  ");}    
        if (Select == 5) {
            lcd.setCursor( 0, 1 );
            lcd.print (" Reglage minute ");} 
        if (Select == 6) {
            lcd.setCursor( 0, 1 );
            lcd.print (" Reglage seconde");}    
        if (Select == 7){
            lcd.setCursor( 0, 1 );
            lcd.print ("      Top !     ");}
        if (Select == 8){
            lcd.setCursor (0,1);
            lcd.print ("                ");
            (Select = 0);
          if (Modif == 1) {  //Remise à l'heure
          RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entrée startAddr dans NV-RAM address 0x08 
          TimeIsSet = 0xffff;
          RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));         
            if (TimeIsSet != 0xaa55)
            {
             RTC.stopClock();        
             RTC.fillByYMD(Annee,Mois,Jour);
             RTC.fillByHMS(Heure,Minute,Seconde);
    
             RTC.setTime();
             TimeIsSet = 0xaa55;
             RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
             RTC.startClock();
            }
            else
            {
            RTC.getTime();
            Modif = 0;
            lcd.clear();
          }
        }         
      }  
    }
         break;
         
   case 25: //Down
        {
        Modif = 1;  
           
        if (Select == 1) {Jour = (Jour - 1);}  
        if (Jour < 1) {(Jour = 31);}
        if (Select == 2){ Mois = (Mois - 1);}
        if (Mois < 1) {(Mois = 12);} 
        if (Select == 3){Annee = (Annee - 1);}
       
        if (Select == 4) {Heure = (Heure - 1);}  
        if (Heure < 1) {(Heure = 23);}
        if (Select == 5){ Minute = (Minute - 1);}
        if (Minute < 1) {(Minute = 59);} 
        if (Select == 6){Seconde = (Seconde - 1);}
        if (Seconde < 1) {(Seconde = 59);}
        }
        break;
        
  case 9: //UP
        { 
        Modif = 1; 
        if (Select == 1) {Jour = (Jour + 1);}  
        if (Jour > 31) {(Jour = 1);}
        if (Select == 2){ Mois = (Mois + 1);}
        if (Mois > 12) {(Mois = 1);} 
        if (Select == 3){Annee = (Annee + 1);}
       
        if (Select == 4) {Heure = (Heure + 1);}  
        if (Heure > 23) {(Heure = 0);}
        if (Select == 5){ Minute = (Minute + 1);}
        if (Minute > 59 ) {(Minute = 0);} 
        if (Select == 6){Seconde = (Seconde + 1);}
        if (Seconde > 59) {(Seconde = 0);}
        }
        break;
   }
 }
   
/////////////////////////////////////////////////    
 void loop ()
 {
 if (Select == 0)
 {   
 RTC.getTime();
 Heure = RTC.hour;
 Minute = RTC.minute;
 Seconde = RTC.second;
 Jour = RTC.day;
 Mois = RTC.month;
 Annee = RTC.year;  

  if ((RTC.second == 00) and (RTC.second != 30)) {
  digitalWrite(Altern1, HIGH);
  digitalWrite(Altern2, LOW);}

  if ((RTC.second == 30)and (RTC.second != 00)) {
  digitalWrite(Altern1, LOW);
  digitalWrite(Altern2, HIGH);}

   if ((RTC.second != 30) and (RTC.second != 00)) {
   digitalWrite(Altern1, LOW);
   digitalWrite(Altern2, LOW);}
 
  lcd.setCursor( 4, 0 );
  if (Heure < 10) {lcd.print ("0");} 
  lcd.print (Heure);
  lcd.print( ":");
  if (Minute < 10) { lcd.print ("0");}
  lcd.print( Minute );
  lcd.print( ":" );
  if (Seconde < 10) { lcd.print ("0");}
  lcd.print( Seconde );
  lcd.print("  ");
  
  lcd.setCursor( 0, 1 );
  if (Jour < 10) { lcd.print ("0");}
  lcd.print(Jour );
  lcd.print( " ");
  //if (Mois < 10) { lcd.print ("0");}
   switch (RTC.month){
    case 1:
       lcd.print  ("Janvier");
     break;
    case 2:
       lcd.print  ("fevrier");
    break;
    case 3:
        lcd.print (" mars  ");
    break;
     case 4:
        lcd.print (" avril ");
    break;
     case 5:
        lcd.print ("  mai  ");
    break;
     case 6:
        lcd.print (" juin  ");
    break;
    case 7:
        lcd.print ("Juillet");
    break;
     case 8:
        lcd.print (" aout  ");
    break;
     case 9:
        lcd.print ("septem.");
    break;
     case 10:
        lcd.print ("octobre");
    break;
     case 11:
        lcd.print ("novemb.");
    break;
     case 12:
        lcd.print ("decemb.");
    break;
    }
        lcd.print( " " );
        lcd.print( Annee );
    }  
   // RAZ valeur de la touche 
  sensorValue = analogRead(sensorPin); // lecture de la touche
  val_key = int(sensorValue/100);       // valeur entière de la touche / 10
    if (val_key < 10)  { Bouton();}
     
   //Avance rapide
    if (val_key == 0)
     {
       digitalWrite (Altern1, HIGH);
       digitalWrite (Altern2, LOW);
         delay(250);
       digitalWrite (Altern1, LOW);
       digitalWrite (Altern2, HIGH);
         delay(250);
      }
     sendFrequency(32768);  // freq
    }
    

   
